/*Copyright (C) 2006  Jean-Franois Geyelin*/

// C Source File
// Created 4/8/2006; 1:11:40 AM

#include "All.h"

//About.c
void drawAbout(void);
//Draw Map Info.c
char drawMapInfo(unsigned char);


/*

*/
static inline void copyWithWaveEffect(char *src, char *dest, int n) {
	short i,j;
	dest+=4*30;
	for (i=9;i>0;i--) {
		char *src1 = src+i;
		char *dest1 = dest+i+(30*(cosTable_512[n]>>7));
		for (j=40;j--;) {
			*dest1=*src1;
			dest1+=30;
			src1+=30;
		}
		n+=9;
		if (n>=128)
		n=0;
	}
}



/*

*/
void xorSelect(short x,short y,short w) {
	
	unsigned char bullet[] ={
		0b00000011,
		0b00000000,
		0b00011111,
		0b00000000,
		0b11111111,

	};
	unsigned char bullet2[] ={
		0b11111111,
		0b00000000,
		0b11111000,
		0b00000000,
		0b11000000,
	};
	w>>=1;
	Sprite8_XOR(x-w-8,y,5,bullet,LCD_MEM);
	Sprite8_XOR(x+w+2,y,5,bullet2,LCD_MEM);
}
	



/*

*/
void aMenu(int *choice2,char ** menuItems,int nItems,int *n2) {
	
	while (_keytest(RR_ESC) || _keytest(RR_ENTER) || _keytest(RR_2ND));
	ClrScr();
	char backGnd[40*30];
	memset(backGnd,0,40*30);
	short i,j;
	char *b = allocatedMem->buffer;
	char e=0b11110000;
	for (i=40*30;i-=30;) {
		for (j=9;j--;) {
			((char*)backGnd)[j+i] = e;
		}
		if (!(i%120))
		e=~e;
	}

	FontSetSys(0);
	

	short dx=240/2;
	short dy=80;
	if (TI89) {
		dx=160/2;		
		dy=65;
	}
	
	short widthStr[nItems];
	
	for (i=nItems;i--;) {
		widthStr[i] = DrawStrWidth(menuItems[i],0);
		DrawStr(dx-(widthStr[i]>>1),dy+8*i,menuItems[i],A_REPLACE);
	}



	
	
	int n=*n2;
	
	short delay=0,choice=*choice2;
	xorSelect(dx,dy+8*choice,widthStr[choice]);
	
		while (!(_keytest(RR_ENTER) || _keytest(RR_2ND))) {
			memset(b,0,60*30);
			copyWithWaveEffect(backGnd,b+30*10+5,n);
			SpriteX8_MASK_R(40,20,31,titleSprite,titleMask,10,b);
			memcpy(LCD_MEM+(TI89?0:14*30+5),b,60*30);
			n++;
			if (n>=128)
			n=0;
			if (_keytest(RR_DOWN) && delay==0 && choice<nItems-1) {
				delay=25;
				xorSelect(dx,dy+8*choice,widthStr[choice]);
				choice++;
				xorSelect(dx,dy+8*choice,widthStr[choice]);
			}
			if (_keytest(RR_ESC)) {
				*choice2 = -1;
				*n2 = n;
				return;
			}
			
			if (_keytest(RR_UP) && delay==0 && choice>0) {
				delay=25;
				xorSelect(dx,dy+8*choice,widthStr[choice]);
				choice--;
				xorSelect(dx,dy+8*choice,widthStr[choice]);
			}		
			delay-=delay>0;
		}
	*choice2 = choice;
	*n2 = n;
	while (_keytest(RR_ESC) || _keytest(RR_ENTER) || _keytest(RR_2ND));
}



/*

*/
char *menuItems1[]={(char*)"Race",(char*)"Info",(char*)"Exit",(char*)""};
char *menuItems2[]={(char*)"3 Laps Race",(char*)"Best Lap",(char*)""};

char menu(int *mapChosen) {
	
	int n=0;
	int choice;
	
label_1:
	choice=0;
	aMenu(&choice,menuItems1,3,&n);
	if (choice==1) {
		drawAbout();
		goto label_1;
	}
	
	if (choice == 2 || choice == -1)
	return 0;
	
label_2:
	choice=(allocatedMem->p.raceMode==THREE_LAPS?0:1);
	aMenu(&choice,menuItems2,2,&n);
	if (choice == -1)
	goto label_1;
	
	allocatedMem->p.raceMode = (choice == 0?THREE_LAPS:BEST_LAP);
	
	char *l[NUMBER_OF_MAP];
	int i;
	for (i=0;i<NUMBER_OF_MAP;i++) {
		l[i] = (char*)&(m[i].name);
	}

label_3:
	choice = allocatedMem->p.mapNumber;
	aMenu(&choice,l,NUMBER_OF_MAP,&n);

	
	if (choice == -1)
	goto label_2;
	*mapChosen = choice;
	allocatedMem->p.map = &m[choice];
	allocatedMem->p.mapNumber = choice;	
	if (!drawMapInfo(choice))
	goto label_3;
	return 1;
	
}